/*******************************************************************************
Chapter 15

Data for leak in house problem p349 Bratko E4.
Major problem is verifying the rules are correct.

Query: is_true_hw(Proposition, Proof).
    is_true_hw(leak_in_kitchen, Proof).
    hall_wet: yes
    bathroom_dry: yes
    window_closed: yes
*******************************************************************************/

:- [f15_9_interact].

if hall_wet and kitchen_dry then leak_in_bathroom.
if hall_wet and bathroom_dry then problem_in_kitchen.
if window_closed or no_rain then no_water_from_outside.
if problem_in_kitchen and no_water_from_outside then leak_in_kitchen.

/*******************************************************************************
Additional clauses for how-why (is_true_hw).
Query: is_true_hw(P, Proof).
*******************************************************************************/

askable(hall_wet).
askable(bathroom_dry).
askable(kitchen_dry).
askable(no_rain).
askable(window_closed).
