/*******************************************************************************
Chapter 15

Data for leak in house problem p349 Bratko E4.
Major problem is verifying the rules are correct.

Query: is_true(leak_in_kitchen).
       is_true(leak_in_kitchen, HowExplanation).
*******************************************************************************/

:- ['knowRepExSys.pl'].

fact(hall_wet).
fact(bathroom_dry).
fact(window_closed).

if hall_wet and kitchen_dry then leak_in_bathroom.
if hall_wet and bathroom_dry then problem_in_kitchen.
if window_closed or no_rain then no_water_from_outside.
if problem_in_kitchen and no_water_from_outside then leak_in_kitchen.

if hall_wet and kitchen_dry then leak_in_bathroom:0.9.
if hall_wet and bathroom_dry then problem_in_kitchen:0.9.
if window_closed or no_rain then no_water_from_outside:1.
if problem_in_kitchen and no_water_from_outside then leak_in_kitchen:0.9.

/*******************************************************************************
Additional clauses for how-why (is_true_hw).
Query: is_true_hw(P, Proof).
*******************************************************************************/

askable(hall_wet).
askable(bathroom_dry).
askable(kitchen_dry).
askable(no_rain).
askable(window_closed).
already_asked(dummy).

/*******************************************************************************
Additional clauses for uncertainty p358.
*******************************************************************************/

given(hall_wet, 1).
given(bathroom_dry, 1).
given(kitchen_dry, 0).
given(no_rain, 0.8).
given(window_closed, 0).
fact_hw(dummy).
