/*******************************************************************************
Chapter 15

Semantic network for Figure 15.11 and program text on page 362.

Queries:
    moving_method('Kim', M).   Move up hierarchy with ';'
    fact(moving_method('Kim', M)).
*******************************************************************************/

colour( kiwi, brown).
colour( albatross, black_and_white).
active_at( kiwi, night).
active_at( bird, daylight).
isa( 'Kim', kiwi).
isa( 'Albert', albatross).
isa( 'Ross', albatross).
isa( albatross, bird).
isa( kiwi, bird).
isa(bird, animal).
moving_method( kiwi, walk).
moving_method( bird, fly).

moving_method( X, Method) :-
    isa( X, SuperX ) ,
    moving_method( SuperX, Method) .

fact( Fact ) :- Fact , ! .

fact( Fact ) :-
    Fact =.. [ Relation , Arg1 , Arg2 ] ,
    isa( Arg1 , SuperArg ) ,
    SuperFact =.. [ Relation , SuperArg , Arg2 ] ,
    fact( SuperFact ) .
